package edu.upvehu.gbg.tap.calculadora;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 * <p>Interfaz gráfico de calculadora sencilla.</p>
 *
 * @author GBG  (german.bordel@ehu.es)
 * @version 20221116
 */
    @SuppressWarnings("unchecked")
public final class CalcuGUI extends javax.swing.JFrame {

    public CalcuGUI() {
        initComponents();
        //Situamos el GUI en el centro de la pantalla
        this.setLocationRelativeTo(null);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        expression = new javax.swing.JLabel();
        display = new javax.swing.JTextField();
        buttons = new javax.swing.JPanel();
        controlButtons = new javax.swing.JPanel();
        clrButton = new javax.swing.JButton();
        calcButtons = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton15 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jButton14 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        typeMenu = new javax.swing.JMenu();
        basicType = new javax.swing.JCheckBoxMenuItem();
        scientificType = new javax.swing.JCheckBoxMenuItem();
        programmerType = new javax.swing.JCheckBoxMenuItem();
        statisticsType = new javax.swing.JCheckBoxMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel2.setLayout(new java.awt.BorderLayout());

        expression.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        expression.setText(" ");
        expression.setToolTipText("");
        expression.setRequestFocusEnabled(false);
        jPanel2.add(expression, java.awt.BorderLayout.PAGE_START);

        display.setEditable(false);
        display.setFont(new java.awt.Font("Tahoma", 0, 24)); // NOI18N
        display.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        display.setText("0");
        jPanel2.add(display, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

        buttons.setLayout(new java.awt.BorderLayout());

        controlButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        clrButton.setFont(new java.awt.Font("Verdana", 0, 10)); // NOI18N
        clrButton.setText("CLR");
        controlButtons.add(clrButton);

        buttons.add(controlButtons, java.awt.BorderLayout.NORTH);

        calcButtons.setLayout(new java.awt.GridLayout(4, 0));

        jButton1.setBackground(new java.awt.Color(0, 153, 255));
        jButton1.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton1.setText("7");
        calcButtons.add(jButton1);

        jButton2.setBackground(new java.awt.Color(0, 153, 255));
        jButton2.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton2.setText("8");
        calcButtons.add(jButton2);

        jButton5.setBackground(new java.awt.Color(0, 153, 255));
        jButton5.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton5.setText("9");
        calcButtons.add(jButton5);

        jButton16.setBackground(new java.awt.Color(51, 255, 51));
        jButton16.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton16.setText("/");
        calcButtons.add(jButton16);

        jButton6.setBackground(new java.awt.Color(0, 153, 255));
        jButton6.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton6.setText("4");
        calcButtons.add(jButton6);

        jButton15.setBackground(new java.awt.Color(0, 153, 255));
        jButton15.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton15.setText("5");
        calcButtons.add(jButton15);

        jButton12.setBackground(new java.awt.Color(0, 153, 255));
        jButton12.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton12.setText("6");
        calcButtons.add(jButton12);

        jButton3.setBackground(new java.awt.Color(51, 255, 51));
        jButton3.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton3.setText("x");
        calcButtons.add(jButton3);

        jButton13.setBackground(new java.awt.Color(0, 153, 255));
        jButton13.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton13.setText("1");
        calcButtons.add(jButton13);

        jButton11.setBackground(new java.awt.Color(0, 153, 255));
        jButton11.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton11.setText("2");
        calcButtons.add(jButton11);

        jButton10.setBackground(new java.awt.Color(0, 153, 255));
        jButton10.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton10.setText("3");
        calcButtons.add(jButton10);

        jButton14.setBackground(new java.awt.Color(51, 255, 51));
        jButton14.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton14.setText("-");
        calcButtons.add(jButton14);

        jButton9.setBackground(new java.awt.Color(0, 153, 255));
        jButton9.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton9.setText("0");
        calcButtons.add(jButton9);

        jButton8.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton8.setText(".");
        calcButtons.add(jButton8);

        jButton4.setBackground(new java.awt.Color(255, 255, 51));
        jButton4.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton4.setText("=");
        calcButtons.add(jButton4);

        jButton7.setBackground(new java.awt.Color(51, 255, 51));
        jButton7.setFont(new java.awt.Font("Verdana", 0, 18)); // NOI18N
        jButton7.setText("+");
        calcButtons.add(jButton7);

        buttons.add(calcButtons, java.awt.BorderLayout.CENTER);

        getContentPane().add(buttons, java.awt.BorderLayout.CENTER);

        typeMenu.setText("Tipo");

        buttonGroup1.add(basicType);
        basicType.setSelected(true);
        basicType.setText("Básica");
        basicType.setName("BásicaOption"); // NOI18N
        typeMenu.add(basicType);

        buttonGroup1.add(scientificType);
        scientificType.setText("Científica");
        scientificType.setName("CientíficaOption"); // NOI18N
        scientificType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeChange(evt);
            }
        });
        typeMenu.add(scientificType);

        buttonGroup1.add(programmerType);
        programmerType.setText("Programador");
        programmerType.setName("ProgramadorOption"); // NOI18N
        programmerType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeChange(evt);
            }
        });
        typeMenu.add(programmerType);

        buttonGroup1.add(statisticsType);
        statisticsType.setText("Estadística");
        statisticsType.setName("EstadísticaOption"); // NOI18N
        statisticsType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeChange(evt);
            }
        });
        typeMenu.add(statisticsType);

        jMenuBar1.add(typeMenu);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void typeChange(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_typeChange
       javax.swing.JCheckBoxMenuItem menuitem=(javax.swing.JCheckBoxMenuItem) evt.getSource();
       javax.swing.JOptionPane.showMessageDialog(this,"<html>¡¡"+ menuitem.getText()+"!!<br/>...demasiado pedir.</html>");
       basicType.setSelected(true);
    }//GEN-LAST:event_typeChange

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBoxMenuItem basicType;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JPanel buttons;
    private javax.swing.JPanel calcButtons;
    private javax.swing.JButton clrButton;
    private javax.swing.JPanel controlButtons;
    private javax.swing.JTextField display;
    private javax.swing.JLabel expression;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JCheckBoxMenuItem programmerType;
    private javax.swing.JCheckBoxMenuItem scientificType;
    private javax.swing.JCheckBoxMenuItem statisticsType;
    private javax.swing.JMenu typeMenu;
    // End of variables declaration//GEN-END:variables

    /**
     * setter para el display.
     * @param s el texto a mostrar en el display
     */
    void setDisplay(String s) {display.setText(s);}

    /**
     * setter para la expresión sobre el display.
     * @param s el texto a mostrar sobre el display
     */
    void setExpression(String s) {expression.setText(s);}

    /**
     * Rutina para asignar un ActionListener a todos los botones.
     * @param controller el ActionListener que ha de atender a los botones
     */
    void subscribirABotones(ActionListener controller) {
        subscribirTotal(getContentPane(),controller);
    }
        
    private void subscribirTotal(Container container, ActionListener controller) {
        for (Component c:container.getComponents()) {
            if (c instanceof JButton) ((JButton)c).addActionListener(controller);
            if (c instanceof JPanel) subscribirTotal((JPanel)c,controller);
        }
    }
}
